##  edit.tcl
##
##		This file implements code for
##		changing text on canvas.
##
##  Copyright (c) 1998 <Irrational Numbers> : <buraldo@maganet.net> 
##
##  This program is free software; you can redistibute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation.
##
##  See the file "license" for information on usage and
##  redistribution of this program, and for a disclaimer of all warranties.
##
##  VER 1.2



namespace eval TXTED {

 proc init {cvs} {
	entry $cvs.edit -bg red
	$cvs.edit configure -textvariable TXTED::CURRTXT

 $cvs bind editable <Enter> {
	set cvs %W
 	set TXTED::OLD_COLOR [$cvs itemcget current -fill]
 	$cvs itemconfig current -fill red
	$cvs configure -cursor xterm 
	set TXTED::ui_msgline "Press <Button3> to edit text"
 }
 $cvs bind editable <Leave> {
	set cvs %W
 	$cvs itemconfig current -fill $TXTED::OLD_COLOR
	$cvs configure -cursor {}
	set TXTED::ui_msgline ""
 }

 $cvs bind editable <Button-3> {
	set cvs %W
	TXTED::simple_editing $cvs [$cvs find withtag current]
 }

  bind $cvs.edit <Return> { 
	TXTED::bind_Return_handler %W
	break
 }

 bind $cvs.edit <Escape> { 
	TXTED::bind_Escape_handler %W
	break
 }
 bind $cvs.edit <Button-3> { 
	TXTED::bind_Escape_handler %W
	break
 }

 } ; # === end of proc init

 set TXT_ID 0
 set WINED_ID 0
 set CURRTXT ""

 proc simple_editing {cvs txtID} {
 	set TXTED::TXT_ID $txtID
	set xyxy [$cvs bbox $TXTED::TXT_ID]
	set x [lindex $xyxy 0]
	set y [lindex $xyxy 1]
 	set TXTED::CURRTXT [$cvs itemcget $TXTED::TXT_ID -text]
	set nCh [string length $TXTED::CURRTXT]
	if {$nCh < 15} { set nCh 15 }
	$cvs.edit configure -width $nCh
	$cvs.edit icursor 0 ; ## ... to do better ...

 	set TXTED::WINED_ID [$cvs create window $x $y -anchor nw -window $cvs.edit]
	tkwait visibility $cvs.edit
	set TXTED::ui_msgline "Press <Enter> to confirm changes --- <Escape> or <Button3> to cancel"
	focus $cvs.edit
 	grab $cvs.edit
 }

 proc bind_Return_handler { w } { 
	variable TXT_ID
	variable CURRTXT
	variable WINED_ID

	set CURRTXT [string trim $CURRTXT]
	set cvs [winfo parent $w]
	### test the text !! to do....
	if { $CURRTXT == "" && [hasTag $cvs $TXTED::TXT_ID docTitle] } {
		tk_messageBox -title "Warning" -icon warning \
			-message "Diagram Name cannot be empty."
		return
	}
	grab release $w
	$cvs itemconfigure $TXT_ID -text $CURRTXT 
	$cvs delete $WINED_ID 
	focus $cvs
	variable ui_msgline
	set ui_msgline ""
 }


 proc bind_Escape_handler { w } {
	variable WINED_ID
	set cvs [winfo parent $w]
	grab release $w
	$cvs delete $WINED_ID 
	focus $cvs
	variable ui_msgline
	set ui_msgline ""
 }
} ; ## = end of namespace =====================================================
