# interface generated by SpecTcl version 1.1 from C:/WINDOWS/DESKTOP/hmsc/pref.ui
#   root     is the parent window for this user interface

proc pref_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1 \
		-borderwidth 4 \
		-relief groove \
		-width 100

	label $base.label#5 \
		-text {Paper Size}

	label $base.label#1 \
		-justify right \
		-text Width

	entry $base.entry1 \
		-textvariable pref(DX)

	label $base.label#3 \
		-justify right \
		-text Heigth

	entry $base.entry2 \
		-textvariable pref(DY)

	button $base.button#1 \
		-command update_pref \
		-text Apply


	# Geometry management

	grid $base.frame#1 -in $root	-row 2 -column 2  \
		-sticky ns
	grid $base.label#5 -in $base.frame#1	-row 1 -column 2 
	grid $base.label#1 -in $base.frame#1	-row 2 -column 1 
	grid $base.entry1 -in $base.frame#1	-row 2 -column 2 
	grid $base.label#3 -in $base.frame#1	-row 3 -column 1 
	grid $base.entry2 -in $base.frame#1	-row 3 -column 2 
	grid $base.button#1 -in $root	-row 4 -column 2  \
		-sticky ew

	# Resize behavior management

	grid rowconfigure $root 1 -weight 0 -minsize 11
	grid rowconfigure $root 2 -weight 0 -minsize 2
	grid rowconfigure $root 3 -weight 0 -minsize 7
	grid rowconfigure $root 4 -weight 0 -minsize 30
	grid rowconfigure $root 5 -weight 0 -minsize 12
	grid columnconfigure $root 1 -weight 0 -minsize 11
	grid columnconfigure $root 2 -weight 0 -minsize 2
	grid columnconfigure $root 3 -weight 0 -minsize 13

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 0 -minsize 29
	grid columnconfigure $base.frame#1 2 -weight 0 -minsize 2
	grid columnconfigure $base.frame#1 3 -weight 0 -minsize 30
# additional interface code


##  pref.tcl
##
##		This file implements code for
##		preferences menu (very little)
##
##  Copyright (c) 1998 <Irrational Numbers> : <buraldo@maganet.net> 
##
##  This program is free software; you can redistibute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation.
##
##  See the file "license" for information on usage and
##  redistribution of this program, and for a disclaimer of all warranties.
##
##  VER 1.2


uplevel #0 {
	set pref(DX) [expr $CVS::XMAX - $CVS::XMIN]
	set pref(DY) [expr $CVS::YMAX - $CVS::YMIN] 

	proc update_pref {} {
		global pref
		if { [catch { CVS::set_paper .c  $CVS::XMIN  $CVS::YMIN \
			[expr $CVS::XMIN+$pref(DX)] [expr $CVS::YMIN+$pref(DY)] } ]
		   } {
			tk_messageBox -icon error -title "illegal input" \
				-message "wrong input in preference-menu; retype"
		} 
	}
}

# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if [info exists embed_args] {
	# we are running in the plugin
	pref_ui .
    } else {
	# we are running in stand-alone mode
	if {$argv0 == [info script]} {
	    wm title . "Testing pref_ui"
	    pref_ui .
	}
    }
}
